Python error 2

python error 2

See: Live Python courses overview Exception handling in Python is very similar to Java. I/O error(2): No such file or directory. Python FileNotFoundError: [Errno 2] No such file or directory Python will raise FileNotFoundError when you use the OS library and try to read. Raise exceptions in Python and catch your errors today! in recursion() 1 def recursion(): > 2 return recursion(). python error 2

Python error 2 - remarkable, rather

8. Errors and Exceptions¶

Until now error messages haven’t been more than mentioned, but if you have tried out the examples you have probably seen some. There are (at least) two distinguishable kinds of errors: syntax errors and exceptions.

Syntax Errors¶

Syntax errors, also known as parsing errors, are perhaps the most common kind of complaint you get while you are still learning Python:

>>> whileTrueprint('Hello world') File "<stdin>", line 1whileTrueprint('Hello world')^SyntaxError: invalid syntax

The parser repeats the offending line and displays a little ‘arrow’ pointing at the earliest point in the line where the error was detected. The error is caused by (or at least detected at) the token preceding the arrow: in the example, the error is detected at the function , since a colon () is missing before it. File name and line number are printed so you know where to look in case the input came from a script.

Exceptions¶

Even if a statement or expression is syntactically correct, it may cause an error when an attempt is made to execute it. Errors detected during execution are called exceptions and are not unconditionally fatal: you will soon learn how to handle them in Python programs. Most exceptions are not handled by programs, however, and result in error messages as shown here:

>>> 10*(1/0)Traceback (most recent call last): File "<stdin>", line 1, in <module>ZeroDivisionError: division by zero>>> 4+spam*3Traceback (most recent call last): File "<stdin>", line 1, in <module>NameError: name 'spam' is not defined>>> '2'+2Traceback (most recent call last): File "<stdin>", line 1, in <module>TypeError: can only concatenate str (not "int") to str

The last line of the error message indicates what happened. Exceptions come in different types, and the type is printed as part of the message: the types in the example are , and . The string printed as the exception type is the name of the built-in exception that occurred. This is true for all built-in exceptions, but need not be true for user-defined exceptions (although it is a useful convention). Standard exception names are built-in identifiers (not reserved keywords).

The rest of the line provides detail based on the type of exception and what caused it.

The preceding part of the error message shows the context where the exception occurred, in the form of a stack traceback. In general it contains a stack traceback listing source lines; however, it will not display lines read from standard input.

Built-in Exceptions lists the built-in exceptions and their meanings.

Handling Exceptions¶

It is possible to write programs that handle selected exceptions. Look at the following example, which asks the user for input until a valid integer has been entered, but allows the user to interrupt the program (using or whatever the operating system supports); note that a user-generated interruption is signalled by raising the exception.

>>> whileTrue try x=int(input("Please enter a number: ")) break exceptValueError print("Oops! That was no valid number. Try again")

The statement works as follows.

  • First, the try clause (the statement(s) between the and keywords) is executed.

  • If no exception occurs, the except clause is skipped and execution of the statement is finished.

  • If an exception occurs during execution of the clause, the rest of the clause is skipped. Then, if its type matches the exception named after the keyword, the except clause is executed, and then execution continues after the try/except block.

  • If an exception occurs which does not match the exception named in the except clause, it is passed on to outer statements; if no handler is found, it is an unhandled exception and execution stops with a message as shown above.

A statement may have more than one except clause, to specify handlers for different exceptions. At most one handler will be executed. Handlers only handle exceptions that occur in the corresponding try clause, not in other handlers of the same statement. An except clause may name multiple exceptions as a parenthesized tuple, for example:

except(RuntimeError,TypeError,NameError)pass

A class in an clause is compatible with an exception if it is the same class or a base class thereof (but not the other way around — an except clause listing a derived class is not compatible with a base class). For example, the following code will print B, C, D in that order:

classB(Exception):passclassC(B):passclassD(C):passforclsin[B,C,D]:try:raisecls()exceptD:print("D")exceptC:print("C")exceptB:print("B")

Note that if the except clauses were reversed (with first), it would have printed B, B, B — the first matching except clause is triggered.

All exceptions inherit from , and so it can be used to serve as a wildcard. Use this with extreme caution, since it is easy to mask a real programming error in this way! It can also be used to print an error message and then re-raise the exception (allowing a caller to handle the exception as well):

importsystry:f=open('sprers.eu')s=sprers.eune()i=int(sprers.eu())exceptOSErroraserr:print("OS error: {0}".format(err))exceptValueError:print("Could not convert data to an integer.")exceptBaseExceptionaserr:print(f"Unexpected {err=}, {type(err)=}")raise

Alternatively the last except clause may omit the exception name(s), however the exception value must then be retrieved from .

The … statement has an optional else clause, which, when present, must follow all except clauses. It is useful for code that must be executed if the try clause does not raise an exception. For example:

sprers.eu[1:]:try:f=open(arg,'r')exceptOSError:print('cannot open',arg)else:print(arg,'has',len(sprers.eunes()),'lines')sprers.eu()

The use of the clause is better than adding additional code to the clause because it avoids accidentally catching an exception that wasn’t raised by the code being protected by the … statement.

When an exception occurs, it may have an associated value, also known as the exception’s argument. The presence and type of the argument depend on the exception type.

The except clause may specify a variable after the exception name. The variable is bound to an exception instance with the arguments stored in . For convenience, the exception instance defines so the arguments can be printed directly without having to reference . One may also instantiate an exception first before raising it and add any attributes to it as desired.

>>> try raiseException('spam','eggs') exceptExceptionasinst print(type(inst))# the exception instance print(sprers.eu)# arguments stored in .args print(inst)# __str__ allows args to be printed directly, # but may be overridden in exception subclasses x,y=sprers.eu# unpack args print('x =',x) print('y =',y)<class 'Exception'>('spam', 'eggs')('spam', 'eggs')x = spamy = eggs

If an exception has arguments, they are printed as the last part (‘detail’) of the message for unhandled exceptions.

Exception handlers don’t just handle exceptions if they occur immediately in the try clause, but also if they occur inside functions that are called (even indirectly) in the try clause. For example:

>>> defthis_fails() x=1/>>> try this_fails() exceptZeroDivisionErroraserr print('Handling run-time error:',err)Handling run-time error: division by zero

Raising Exceptions¶

The statement allows the programmer to force a specified exception to occur. For example:

>>> raiseNameError('HiThere')Traceback (most recent call last): File "<stdin>", line 1, in <module>NameError: HiThere

The sole argument to indicates the exception to be raised. This must be either an exception instance or an exception class (a class that derives from ). If an exception class is passed, it will be implicitly instantiated by calling its constructor with no arguments:

raiseValueError# shorthand for 'raise ValueError()'

If you need to determine whether an exception was raised but don’t intend to handle it, a simpler form of the statement allows you to re-raise the exception:

>>> try raiseNameError('HiThere') exceptNameError print('An exception flew by!') raiseAn exception flew by!Traceback (most recent call last): File "<stdin>", line 2, in <module>NameError: HiThere

Exception Chaining¶

The statement allows an optional which enables chaining exceptions. For example:

# exc must be exception instance or sprers.euuntimeErrorfromexc

This can be useful when you are transforming exceptions. For example:

>>> deffunc() raiseConnectionError>>> try func() exceptConnectionErrorasexc raiseRuntimeError('Failed to open database')fromexcTraceback (most recent call last): File "<stdin>", line 2, in <module> File "<stdin>", line 2, in funcConnectionErrorThe above exception was the direct cause of the following exception:Traceback (most recent call last): File "<stdin>", line 4, in <module>RuntimeError: Failed to open database

Exception chaining happens automatically when an exception is raised inside an or section. This can be disabled by using idiom:

>>> try open('sprers.eu') exceptOSError raiseRuntimeErrorfromNoneTraceback (most recent call last): File "<stdin>", line 4, in <module>RuntimeError

For more information about chaining mechanics, see Built-in Exceptions.

User-defined Exceptions¶

Programs may name their own exceptions by creating a new exception class (see Classes for more about Python classes). Exceptions should typically be derived from the class, either directly or indirectly.

Exception classes can be defined which do anything any other class can do, but are usually kept simple, often only offering a number of attributes that allow information about the error to be extracted by handlers for the exception.

Most exceptions are defined with names that end in “Error”, similar to the naming of the standard exceptions.

Many standard modules define their own exceptions to report errors that may occur in functions they define. More information on classes is presented in chapter Classes.

Defining Clean-up Actions¶

The statement has another optional clause which is intended to define clean-up actions that must be executed under all circumstances. For example:

>>> try raiseKeyboardInterrupt finally print('Goodbye, world!')Goodbye, world!KeyboardInterruptTraceback (most recent call last): File "<stdin>", line 2, in <module>

If a clause is present, the clause will execute as the last task before the statement completes. The clause runs whether or not the statement produces an exception. The following points discuss more complex cases when an exception occurs:

  • If an exception occurs during execution of the clause, the exception may be handled by an clause. If the exception is not handled by an clause, the exception is re-raised after the clause has been executed.

  • An exception could occur during execution of an or clause. Again, the exception is re-raised after the clause has been executed.

  • If the clause executes a , or statement, exceptions are not re-raised.

  • If the statement reaches a , or statement, the clause will execute just prior to the , or statement’s execution.

  • If a clause includes a statement, the returned value will be the one from the clause’s statement, not the value from the clause’s statement.

For example:

>>> defbool_return() try returnTrue finally returnFalse>>> bool_return()False

A more complicated example:

>>> defdivide(x,y) try result=x/y exceptZeroDivisionError print("division by zero!") else print("result is",result) finally print("executing finally clause")>>> divide(2,1)result is executing finally clause>>> divide(2,0)division by zero!executing finally clause>>> divide("2","1")executing finally clauseTraceback (most recent call last): File "<stdin>", line 1, in <module> File "<stdin>", line 3, in divideTypeError: unsupported operand type(s) for /: 'str' and 'str'

As you can see, the clause is executed in any event. The raised by dividing two strings is not handled by the clause and therefore re-raised after the clause has been executed.

In real world applications, the clause is useful for releasing external resources (such as files or network connections), regardless of whether the use of the resource was successful.

Predefined Clean-up Actions¶

Some objects define standard clean-up actions to be undertaken when the object is no longer needed, regardless of whether or not the operation using the object succeeded or failed. Look at the following example, which tries to open a file and print its contents to the screen.

forlineinopen("sprers.eu"):print(line,end="")

The problem with this code is that it leaves the file open for an indeterminate amount of time after this part of the code has finished executing. This is not an issue in simple scripts, but can be a problem for larger applications. The statement allows objects like files to be used in a way that ensures they are always cleaned up promptly and correctly.

withopen("sprers.eu")asf:forlineinf:print(line,end="")

After the statement is executed, the file f is always closed, even if a problem was encountered while processing the lines. Objects which, like files, provide predefined clean-up actions will indicate this in their documentation.

I'm setting up a keylogger for my mac OS to track esports reaction times. Most of the code is fine, with pynput installed successfully and the code seeming to check out, however when I go to run the code in Visual studio code (my text editor) i get the error:

'can't open file 'sprers.eu': [Errno 2] No such file or directory'

can anyone help me with this? i'm quite new to python so i'm sure its a simple fix i've not done!

My python code is:

from sprers.eurd import Key, Listener #vanilla import logging #make a log file log_dir = "" sprers.euonfig(filename=(log_dir + "key_sprers.eu"), level=sprers.eu, format='%(asctime)s: %(message)s:') def on_press(key): sprers.eu(str(key)) #if key == sprers.eu: #stop listener #return false with Listener(on_press=on_press) as listener: sprers.eu()And my terminal is:

PS /Users/dav3javu/Desktop/keylogger/pynput-master> python3 sprers.eu /Library/Frameworks/sprers.euork/Versions//Resources/sprers.eu /Contents/MacOS/Python: can't open file 'sprers.eu': [Errno 2] No such file or directory
') print(df)

Result:

method_ide_paste_sprers.eu

Conclusion

In this article, we have observed the different cases where the system cannot locate your files. We also looked at the different solutions that are possible to these problems, from manually specifying paths, to using IDE&#;s for a better outcome. I hope this article solved your problem